﻿using Ganss.Xss;

namespace StudioKit.Scaffolding.BusinessLogic.Utils;

public static class ArtifactHtmlSanitizeSettings
{
	public static string Sanitize(string html)
	{
		var settings = new HtmlSanitizer();

		settings.AllowedAttributes.Add("class");
		settings.AllowedAttributes.Add("aria-hidden");
		settings.AllowedAttributes.Add("data-value");
		settings.AllowedAttributes.Add("encoding");
		settings.AllowedAttributes.Add("allowfullscreen");
		settings.AllowedAttributes.Add("frameborder");

		settings.AllowedSchemes.Add("mailto");
		settings.AllowedSchemes.Add("data");

		settings.AllowedTags.Add("iframe");

		settings.AllowedTags.UnionWith(MathMLTags);

		return settings.Sanitize(html);
	}

	// Allowed MathML tags. Source: https://github.com/wooorm/mathml-tag-names
	// ReSharper disable once InconsistentNaming
	private static readonly string[] MathMLTags =
	{
		"abs",
		"and",
		"annotation",
		"annotation-xml",
		"apply",
		"approx",
		"arccos",
		"arccosh",
		"arccot",
		"arccoth",
		"arccsc",
		"arccsch",
		"arcsec",
		"arcsech",
		"arcsin",
		"arcsinh",
		"arctan",
		"arctanh",
		"arg",
		"bind",
		"bvar",
		"card",
		"cartesianproduct",
		"cbytes",
		"ceiling",
		"cerror",
		"ci",
		"cn",
		"codomain",
		"complexes",
		"compose",
		"condition",
		"conjugate",
		"cos",
		"cosh",
		"cot",
		"coth",
		"cs",
		"csc",
		"csch",
		"csymbol",
		"curl",
		"declare",
		"degree",
		"determinant",
		"diff",
		"divergence",
		"divide",
		"domain",
		"domainofapplication",
		"emptyset",
		"encoding",
		"eq",
		"equivalent",
		"eulergamma",
		"exists",
		"exp",
		"exponentiale",
		"factorial",
		"factorof",
		"false",
		"floor",
		"fn",
		"forall",
		"function",
		"gcd",
		"geq",
		"grad",
		"gt",
		"ident",
		"image",
		"imaginary",
		"imaginaryi",
		"implies",
		"in",
		"infinity",
		"int",
		"integers",
		"intersect",
		"interval",
		"inverse",
		"lambda",
		"laplacian",
		"lcm",
		"leq",
		"limit",
		"list",
		"ln",
		"log",
		"logbase",
		"lowlimit",
		"lt",
		"m:apply",
		"m:mrow",
		"maction",
		"malign",
		"maligngroup",
		"malignmark",
		"malignscope",
		"math",
		"matrix",
		"matrixrow",
		"max",
		"mean",
		"median",
		"menclose",
		"merror",
		"mfenced",
		"mfrac",
		"mfraction",
		"mglyph",
		"mi",
		"mi\"",
		"min",
		"minus",
		"mlabeledtr",
		"mlongdiv",
		"mmultiscripts",
		"mn",
		"mo",
		"mode",
		"moment",
		"momentabout",
		"mover",
		"mpadded",
		"mphantom",
		"mprescripts",
		"mroot",
		"mrow",
		"ms",
		"mscarries",
		"mscarry",
		"msgroup",
		"msline",
		"mspace",
		"msqrt",
		"msrow",
		"mstack",
		"mstyle",
		"msub",
		"msubsup",
		"msup",
		"mtable",
		"mtd",
		"mtext",
		"mtr",
		"munder",
		"munderover",
		"naturalnumbers",
		"neq",
		"none",
		"not",
		"notanumber",
		"notin",
		"notprsubset",
		"notsubset",
		"or",
		"otherwise",
		"outerproduct",
		"partialdiff",
		"pi",
		"piece",
		"piecewice",
		"piecewise",
		"plus",
		"power",
		"primes",
		"product",
		"prsubset",
		"quotient",
		"rationals",
		"real",
		"reals",
		"reln",
		"rem",
		"root",
		"scalarproduct",
		"sdev",
		"sec",
		"sech",
		"select",
		"selector",
		"semantics",
		"sep",
		"set",
		"setdiff",
		"share",
		"sin",
		"sinh",
		"span",
		"subset",
		"sum",
		"tan",
		"tanh",
		"tendsto",
		"times",
		"transpose",
		"true",
		"union",
		"uplimit",
		"var",
		"variance",
		"vector",
		"vectorproduct",
		"xor"
	};
}